------------------------------ MODULE FastMPGC ------------------------------

(* The specification of fast modes *) 

EXTENDS FiniteSets, Naturals, Library, Generic, TLCDefs

CONSTANTS Initial, Acceptor

CONSTANTS RespQuorum, AbortQuorum, None

INSTANCE FastMPGCDefs

VARIABLES status, pending, initVals, dState, accStatus, interface, 
  abortVals, pastPending

INSTANCE MPGC

slin_status == [p \in P |-> IF status[p] \in {"pending","panic"} THEN "pending" ELSE status[p]]
slin_pending == pending
slin_dState == Max({GLB(AccStates(Q)) : Q \in RespQuorum}, LAMBDA a,b : a \preceq b)
slin_interface == interface
slin_initialized == 
  IF Initial THEN TRUE
  ELSE \E Q \in RespQuorum : \A a \in Q : accStatus[a] # "idle"
slin_initVals == initVals
slin_abortVals == abortVals

SLin == INSTANCE SpecLin WITH
    status <- slin_status,
    pending <- slin_pending,
    dState <- slin_dState,
    interface <- slin_interface,
    initialized <- slin_initialized,
    initVals <- slin_initVals,
    abortVals <- slin_abortVals

THEOREM Spec => SLin!Spec

=============================================================================
\* Modification History
\* Last modified Fri Jan 24 16:37:22 CET 2014 by losa
\* Created Fri Nov 29 14:19:05 CET 2013 by losa
